Const DATA_PATH$ = "data\"


Function DatabaseIndex()
	Local file, test
	
	;what label to use for this dataset?
	database_index=-1
	test=0
	While database_index=-1
		;check if file exists
		file=ReadFile (DATA_PATH$+test+"-ok.txt")
		If file Then
			;already exists, move to next
			CloseFile file
			test=test+1
		Else
			;not exist, use this value
			database_index=test
		EndIf			
	Wend
	
	;DebugLog "Using index "+database_index
	
End Function

Function SaveIslands(idx)
	Local file, c

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Save island data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	;count islands
	c=0
	For i.island=Each island
		c=c+1
	Next

	;open output file
	file = WriteFile (DATA_PATH$+idx+"-islands.txt")

	;save index
	WriteLine file,c

	;save data
	For i.island =Each island
		WriteLine file,i\ocean
		WriteLine file,i\sector
		WriteLine file,i\isle
		WriteLine file,i\rulerid
		WriteLine file,i\rulername$
		WriteLine file,i\allianceid
		WriteLine file,i\alliancetag$
	Next
	
	;housekeeping
	CloseFile file
	
	;DebugLog "Saved island data to data\+"+idx+"-islands.txt"
;	count_islands = c
	
End Function

Function SavePlayers(idx)
	Local file, c
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Save player data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	;count islands
	c=0
	For p.player=Each player
		c=c+1
	Next

	;open output file
	file = WriteFile (DATA_PATH$+idx+"-players.txt")

	;save index
	WriteLine file,c

	;save data
	For p.player=Each player
		WriteLine file,p\id
		WriteLine file,p\name$
		WriteLine file,p\islands
		WriteLine file,p\score
		WriteLine file,p\rank
		WriteLine file,p\allianceid
		WriteLine file,p\alliancetag$
	Next
	
	;housekeeping
	CloseFile file
	
	;DebugLog "Saved player data to data\"+idx+"-players.txt"
;	count_players = c
	
End Function

Function SaveAlliances(idx)
	Local file, c
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Save alliance data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	;count islands
	c=0
	For a.alliance=Each alliance
		c=c+1
	Next

	;open output file
	file = WriteFile (DATA_PATH$+idx+"-alliances.txt")

	;save index
	WriteLine file,c

	;save data
	For a.alliance=Each alliance
		WriteLine file,a\id
		WriteLine file,a\tag$
		WriteLine file,a\score
		WriteLine file,a\rank
		WriteLine file,a\members
		WriteLine file,a\islands
	Next
	
	;housekeeping
	CloseFile file
	
	;DebugLog "Saved alliance data to data\"+idx+"-alliances.txt"
;	count_alliances = c
	
End Function






Function LoadIslands(index)
	file = ReadFile (DATA_PATH$+index+"-islands.txt")

	count = ReadLine (file)
	
	For c=1 To count
		i.island = New island
		i\ocean = ReadLine (file)
		i\sector = ReadLine (file)
		i\isle = ReadLine (file)
		i\rulerid = ReadLine (file)
		i\rulername$ = ReadLine (file)
		i\allianceid = ReadLine (file)
		i\alliancetag$ = ReadLine (file)
	Next
	
	CloseFile file
End Function

;cache players
Function LoadPlayers(index)
	file = ReadFile (DATA_PATH+index+"-players.txt")

	count = ReadLine (file)
	
	For c=1 To count
		p.player = New player
		p\id = ReadLine (file)
		p\name$ = ReadLine (file)
		p\islands = ReadLine (file)
		p\score = ReadLine (file)
		p\rank = ReadLine (file)
		p\allianceid = ReadLine (file)
		p\alliancetag$ = ReadLine (file)
	Next
	
	CloseFile file
End Function

;cache alliances
Function LoadAlliances(index)
	file = ReadFile (DATA_PATH+index+"-alliances.txt")

	count = ReadLine (file)
	
	For c=1 To count
		a.alliance = New alliance
		a\id = ReadLine (file)
		a\tag$ = ReadLine (file)
		a\score = ReadLine (file)
		a\rank = ReadLine (file)
		a\members = ReadLine (file)
		a\islands = ReadLine (file)
	Next
	
	CloseFile file
End Function